"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var IncIndex_1 = require("./IncIndex");
exports.IncIndex = IncIndex_1.IncIndex;
/**
 * type operations for 'lists' -- numerically-indexed types (tuple/object) with explicit `length`.
 * outputs are not tuple types but similar 'list' objects, because we can't manipulate tuples yet.
 *
 * Examples:
 * - `[number, string]` (tuple: fixed-length array)
 * - `{ 0: number, 1: string, length: 2 }` (`ArrayLike` with known `length`, which includes tuples)
 *
 * @preferred
 */
