"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tsst_tycho_1 = require("tsst-tycho");
describe(`comp`, () => {
    describe(`StringsEqual`, () => {
        it(`the<'1', StringsEqual<'a', 'a'>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
        it(`the<'0', StringsEqual<'a', 'b'>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
    });
    describe(`NumbersEqual`, () => {
        it(`the<'1', NumbersEqual<123, 123>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
        it(`the<'0', NumbersEqual<123, 456>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
        it(`the<'1', NumbersEqual<123, '123'>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the(); // numbers only
            }).expectToFail();
        });
        it(`the<'1', NumbersEqual<'123', 123>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the(); // numbers only
            }).expectToFail();
        });
        it(`the<'0', NumbersEqual<0, 5>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
        it(`the<'0', NumbersEqual<5, 0>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
    });
    describe(`Gt`, () => {
        it(`the<'1', Gt<3, 2>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
        it(`the<'0', Gt<2, 3>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
        it(`the<'0', Gt<3, 3>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
    });
    describe(`Lt`, () => {
        it(`the<'0', Lt<3, 2>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
        it(`the<'1', Lt<2, 3>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
        it(`the<'0', Lt<3, 3>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
    });
    describe(`Gte`, () => {
        it(`the<'1', Gte<3, 2>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
        it(`the<'0', Gte<2, 3>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
        it(`the<'1', Gte<3, 3>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
    });
    describe(`Lte`, () => {
        it(`the<'0', Lte<3, 2>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
        it(`the<'1', Lte<2, 3>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
        it(`the<'1', Lte<3, 3>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
    });
    describe(`Max`, () => {
        it(`the<6, Max<3, 6>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
        it(`the<5, Max<5, 2>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
    });
    describe(`Min`, () => {
        it(`the<3, Min<3, 6>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
        it(`the<2, Min<5, 2>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
    });
});
