"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tsst_tycho_1 = require("tsst-tycho");
// https://github.com/Microsoft/TypeScript/issues/12215#issuecomment-307871458
// type sfsd = { [P in PrototypeMethods]: P;　[k: string]: never; };
// type sdkjdsl = { toString: "toString"; [P in keyof "a"]: never };
// type sdkjds2l = { [P in keyof U]: never; [K in keyof PrototypeMethods]: K; };
describe(`object`, () => {
    describe(`Keyed`, () => {
        it(`the<{a:'a',b:'b'}, Keyed<{a:1,b:2}>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
    });
    describe(`KeyedSafe`, () => {
        it(`the<{a:'a',b:'b'} & Obj<never>, KeyedSafe<{a:1} & {b:2}>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
    });
    describe(`ObjectHasKey`, () => {
        it(`the<'1', ObjectHasKey<{a:1}, 'a'>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
        it(`the<'0', ObjectHasKey<{a:1}, 'b'>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
        it(`the<'0'|'1', ObjectHasKey<{a?:1}, 'a'>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
        it(`the<'1', ObjectHasKey<NumArr, 1>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToFail();
        });
        it(`the<'0', ObjectHasKey<NumArr, -1>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToFail();
        });
        it(`the<'0', ObjectHasKey<{ a: 1 }, "toString">>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
        // ^ error: () => string
    });
    describe(`HasKey`, () => {
        it(`the<'0', HasKey<any[], 2>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
        it(`the<'1', HasKey<NumArr, 2>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
        // ^ error: 0
        it(`the<'0', HasKey<NumArr, 5>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
        it(`the<'1', HasKey<{ a: 1 }, 'a'>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
        // ^ error: 0
        it(`the<'0', HasKey<{ a: 1 }, 'b'>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
    });
    describe(`ObjectHasKeySafe`, () => {
        it(`the<'1', ObjectHasKeySafe<{ a: 1 }, 'a'>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
        it(`the<'0', ObjectHasKeySafe<{ a: 1 }, 'b'>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
        it(`the<'1', ObjectHasKeySafe<{ a: 1 }, 'a' | 'b'>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
        it(`the<'1', ObjectHasKeySafe<{ a: 1, toString(): string }, 'a'>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
        it(`the<'0', ObjectHasKeySafe<{ a: 1, toString(): string }, 'b'>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
        // error: 1 :(
        it(`the<'1', ObjectHasKeySafe<{ a: 1, toString(): string }, 'a' | 'b'>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
        it(`the<'0', ObjectHasKeySafe<{ a: 1 }, 'toString'>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the(); // what do I want?
            }).expectToCompile();
        });
        it(`the<'1', ObjectHasKeySafe<{ a: 1 }, 'toString' | 'a'>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
        it(`the<'0', ObjectHasKeySafe<{ a: 1 }, 'toString' | 'b'>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the(); // what do I want?
            }).expectToCompile();
        });
        it(`the<'1', ObjectHasKeySafe<{ a: 1 }, 'toString' | 'a' | 'b'>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
        it(`the<'1', ObjectHasKeySafe<{ a: 1, toString(): string }, 'toString'>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
        it(`the<'1', ObjectHasKeySafe<{ a: 1, toString(): string }, 'toString' | 'a'>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
        it(`the<'1', ObjectHasKeySafe<{ a: 1, toString(): string }, 'toString' | 'b'>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
        it(`the<'1', ObjectHasKeySafe<{ a: 1, toString(): string }, 'toString' | 'a' | 'b'>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
    });
    // if this works, I may need to replace string member access with this in other places...
    describe(`ObjectProp`, () => {
        it(`the<1, ObjectProp<{ a: 1 }, 'a'>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
        it(`the<never, ObjectProp<{ a: 1 }, 'b'>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
        it(`the<never, ObjectProp<{ a: 1 }, 'toString'>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
        it(`the<1, ObjectProp<{ a: 1, toString(): string }, 'a'>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
        it(`the<never, ObjectProp<{ a: 1, toString(): string }, 'b'>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
        // error: any :(
        it(`the<() => string, ObjectProp<{ a: 1, toString(): string }, 'toString'>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
    });
    describe(`Omit`, () => {
        it(`the<{ b: number, c: boolean }, Omit<Item1, "a">>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
        it(`the<'b'|'c'|'toString', Exclude<keyof ItemA, "a">>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
        it(`the<{ b: number, c: boolean, toString(): string }, Omit<ItemA, "a">>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
    });
    describe(`Overwrite`, () => {
        it(`the<{ a: number, b: number, c: boolean }, Overwrite<Item1, Item2>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
        // keys optional in 2nd arg: works without `strictNullChecks`
    });
    describe(`IntersectionObjectKeys`, () => {
        it(`the<'b', IntersectionObjectKeys<Obj1, Obj2>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
    });
    describe(`IntersectionObjects`, () => {
        it(`the<{ b: 2 }, IntersectionObjects<Obj1, Obj2>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
        it(`the<{ b: 'X' }, IntersectionObjects<Obj2, Obj1>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
    });
    describe(`ObjectValsToUnion`, () => {
        it(`the<1|2, ObjectValsToUnion<Obj1>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
    });
    describe(`Simplify`, () => {
        it(`the<{ a: 1, b: 2}, Simplify<{ a: 1 } & { b: 2}>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
    });
    describe(`Swap`, () => {
        it(`the<{ b: 'a', d: 'c' }, Swap<{ a: 'b', c: 'd' }>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
    });
    describe(`toString experimenting`, () => {
        it(`the<{ a: 1, foo: () => string, toString: () => string }, Omit<abc, "b">>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
        it(`the<{ a: 1, b: 2, foo: () => string }, Omit<abc, "toString">>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
        it(`the<abc, Simplify<abc & { "b": never }>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
        it(`the<{ a: 1, b: any, foo: () => string, toString: () => string }, Simplify<abc & { "b": any }>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
        it(`the<abc, Simplify<abc & { "toString": never }>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
        it(`the<{ a: 1, b: 2, foo: () => string, toString: any }, Simplify<abc & { "toString": any }>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
        it(`the<abc, Simplify<abc & { "foo": never }>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
        it(`the<{ a: 1, b: 2, foo: any, toString: () => string }, Simplify<abc & { "foo": any }>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
        it(`the<{ a: 1, b: never, foo: () => string, toString: () => string }, Overwrite<abc, { "b": never }>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
        it(`the<{ a: 1, b: any, foo: () => string, toString: () => string }, Overwrite<abc, { "b": any }>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
        it(`the<{ a: 1, b: 2, foo: () => string }, Overwrite<abc, { "toString": never }>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
        it(`the<{ a: 1, b: 2, foo: () => string, toString: any }, Overwrite<abc, { "toString": any }>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
        it(`the<{ a: 1, b: 2, foo: never, toString: () => string }, Overwrite<abc, { "foo": never }>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
        it(`the<{ a: 1, b: 2, foo: any, toString: () => string }, Overwrite<abc, { "foo": any }>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
        it(`the<abc, Simplify<abc & { "toString": never }>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
        it(`the<'1', ObjectHasStringIndex<{ [k: string]: 123 }>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
        it(`the<'0', ObjectHasStringIndex<{ a: 123 }>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
    });
    describe(`StripIndex`, () => {
        it(`the<StripIndex<{ a: 1, [k: string]: number }>, { a: 1 }>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
    });
    describe(`Jsonified`, () => {
        it(`the<{ b: 'a' }, Jsonified<{ b: 'a', d: undefined, f: () => void }>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
    });
    describe(`IntersectValueOf`, () => {
        it(`IntersectValueOf`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
                tsst_tycho_1.the();
                tsst_tycho_1.the();
            }).expectToCompile();
        });
    });
    describe(`DeepWiden`, () => {
        it(`the<{ a: number }, DeepWiden<{ a: 1 }>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
    });
    describe(`DeepPartial`, () => {
        it(`the<{ a?: { b?: 1 } }, DeepPartial<{ a: { b: 1 } }>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
        it(`the<1, DeepPartial<{ a: [{ b: 1 }] }>['a'][0]['b']>`, () => {
            tsst_tycho_1.tsst(() => {
                let o = null;
                if (typeof o.a === 'undefined') { }
                else {
                    let b = o.a[0].b;
                    if (typeof b === 'number') {
                        let c = b;
                    }
                    else {
                        let c = b;
                    }
                }
            }).expectToCompile();
        });
    });
    describe(`DeepRequired`, () => {
        it(`the<{ a: { b: 1 } }, DeepRequired<{ a?: { b?: 1 } }>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
    });
    describe(`Mutable`, () => {
        it(`the<{ a: 1 }, Mutable<{ readonly a: 1 }>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
    });
    describe(`DeepMutable`, () => {
        it(`the<{ a: { b: 1 } }, DeepMutable<{ readonly a: { readonly b: 1 } }>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
    });
    describe(`DeepAssert`, () => {
        it(`the<{ a: 1 }, DeepAssert<{ a: 1|null }>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
    });
    describe(`DeepReadonly`, () => {
        it(`still allows reading`, () => {
            tsst_tycho_1.tsst(() => {
                function f10(part) {
                    let name = part.name;
                    let id = part.subparts[0].id;
                }
            }).expectToCompile();
        });
        it(`disallows writing - layer 0`, () => {
            tsst_tycho_1.tsst(() => {
                function f10(part) {
                    part.id = part.id;
                }
            }).expectToFailWith('read-only');
        });
        it(`disallows writing - layer 1`, () => {
            tsst_tycho_1.tsst(() => {
                function f10(part) {
                    part.subparts[0] = part.subparts[0];
                }
            }).expectToFailWith('only permits reading');
        });
        it(`disallows writing - layer 2`, () => {
            tsst_tycho_1.tsst(() => {
                function f10(part) {
                    part.subparts[0].id = part.subparts[0].id;
                }
            }).expectToFailWith('read-only');
        });
        it(`strips out methods`, () => {
            tsst_tycho_1.tsst(() => {
                function f10(part) {
                    part.updatePart("hello");
                }
            }).expectToFailWith('does not exist');
        });
    });
    describe(`LiteralPropNames`, () => {
        it(`the<'a', LiteralPropNames<{ a: 1, [k: string]: number }>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
    });
    describe(`LiteralProps`, () => {
        it(`the<{ a: 1 }, LiteralProps<{ a: 1, [k: string]: number }>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
    });
    describe(`FunctionPropNames`, () => {
        it(`the<'f', FunctionPropNames<{ a: 1, f: () => void }>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
    });
    describe(`FunctionProps`, () => {
        it(`the<{ f: () => void }, FunctionProps<{ a: 1, f: () => void }>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
    });
    describe(`NonFunctionPropNames`, () => {
        it(`the<'a', NonFunctionPropNames<{ a: 1, f: () => void }>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
    });
    describe(`NonFunctionProps`, () => {
        it(`the<{ a: 1 }, NonFunctionProps<{ a: 1, f: () => void }>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
    });
    describe(`MatchingPropNames`, () => {
        it(`the<'f', MatchingPropNames<{ a: 1, f: true }, boolean>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
    });
    describe(`MatchingProps`, () => {
        it(`the<{ f: true }, MatchingProps<{ a: 1, f: true }, boolean>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
    });
    describe(`NonMatchingPropNames`, () => {
        it(`the<'a', NonMatchingPropNames<{ a: 1, f: true }, boolean>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
    });
    describe(`NonMatchingProps`, () => {
        it(`the<{ a: 1 }, NonMatchingProps<{ a: 1, f: true }, boolean>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
    });
    describe(`OptionalPropNames`, () => {
        it(`the<'a', OptionalPropNames<{ a?: 1, b: 2 }>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
    });
    describe(`OptionalProps`, () => {
        it(`the<{ a?: 1 }, OptionalProps<{ a?: 1, b: 2 }>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
    });
    describe(`RequiredPropNames`, () => {
        it(`the<'b', RequiredPropNames<{ a?: 1, b: 2 }>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
    });
    describe(`RequiredProps`, () => {
        it(`the<{ b: 2 }, RequiredProps<{ a?: 1, b: 2 }>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
    });
    describe(`Spread`, () => {
        it(`the<{ a: number, b: number, c: boolean }, Spread<Item1, Item2>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
        // keys optional in 2nd arg: works without `strictNullChecks`
        it(`the<AB, Spread<A, B>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
    });
    describe(`ObjectHasNumberIndex`, () => {
        it(`the<'0', ObjectHasNumberIndex<{ 0: 'a' }>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
        it(`the<'0', ObjectHasNumberIndex<['a']>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
        it(`the<'1', ObjectHasNumberIndex<{ [i: number]: 'a' }>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
        it(`the<'1', ObjectHasNumberIndex<'a'[]>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
    });
    describe(`ObjectHasElem`, () => {
        it(`the<'1', ObjectHasElem<{ a: 1 }, 1>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
        it(`the<'0', ObjectHasElem<{ a: 1 }, 0>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
    });
    describe(`ObjectNumberKeys`, () => {
        it(`the<'0'|'1', ObjectNumberKeys<['a','b']>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
        it(`the<'0'|'1', ObjectNumberKeys<{0:'a',1:'b',length:2}>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
    });
    // describe(``, () => {
    //   it(``, () => {
    //     tsst(() => {
    //       the<>();
    //     }).expectToCompile();
    //   });
    // });
});
