"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tsst_tycho_1 = require("tsst-tycho");
describe(`ramda`, () => {
    describe(`PathFn`, () => {
        it(`the<'e', PathFn<{ a: { b: ['c', { d: 'e' }] } }, ['a', 'b', '1', 'd']>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
        it(`path`, () => {
            tsst_tycho_1.tsst(() => {
                let obj = { a: { b: ['c', { d: 'e' }] } };
                let keys = ['a', 'b', '1', 'd'];
                const pathTest = path(obj, keys);
            }).expectToCompile();
        });
    });
    describe(`PathOrFn`, () => {
        it(`the<'e', PathOrFn<{ a: { b: ['c', { d: 'e' }] } }, "oh", ['a', 'b', 1, 'd']>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
                // ^ error: 'oh'
                // ^ regression in recent TS?
            }).expectToCompile();
        });
        it(`the<'oh', PathOrFn<{ a: { b: ['c', { d: 'e' }] } }, "oh", ['a', 'b', 4]>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
    });
    describe(`MergeAllFn`, () => {
        it(`the<{ a: 1, b: 3, c: 4, d: 5 }, MergeAllFn<[{ a: 1, b: 2 }, { b: 3, c: 4 }, { d: 5 }]>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
    });
    describe(`FromPairsFn`, () => {
        it(`the<{ a: 5, b: 2, c: 3 }, FromPairsFn<[['a', 1], ['b', 2], ['c', 3], ['a', 5]]>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
    });
    describe(`ZipObjectFn`, () => {
        it(`the<{ a: 1, b: 2, c: 3 }, ZipObjectFn<['a', 'b', 'c'], [1, 2, 3]>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
    });
    describe(`#12838`, () => {
        let inc; // +1
        let identity;
        let compose;
        let pipe;
        it(`identity`, () => {
            tsst_tycho_1.tsst(() => {
                let a = identity(0);
            }).expectToFailWith(`not assignable to type 'string'`);
        });
        // don't use generics if it can't resolve them right away:
        it(`compose + generics`, () => {
            tsst_tycho_1.tsst(() => {
                let a = compose(identity)(0); // generics lost, now {} => {}
            }).expectToFailWith(`not assignable to type 'string'`);
        });
        it(`pipe + generics`, () => {
            tsst_tycho_1.tsst(() => {
                let a = pipe(identity)(0); // ditto
            }).expectToFailWith(`not assignable to type 'string'`);
        });
        // argument order apparently matters too:
        it(`compose + generics: concrete type first`, () => {
            tsst_tycho_1.tsst(() => {
                let a = compose(identity, inc)(0); // nope, number => {}
            }).expectToFailWith(`not assignable to type 'string'`);
        });
        it(`pipe + generics: concrete type first`, () => {
            tsst_tycho_1.tsst(() => {
                let a = pipe(inc, identity)(0); // ok, number -> number
            }).expectToFailWith(`not assignable to type 'string'`);
        });
        // also no reasoning backward:
        it(`compose + generics: concrete type last`, () => {
            tsst_tycho_1.tsst(() => {
                let a = compose(inc, identity)(0); // {} => number
            }).expectToFailWith(`not assignable to type 'string'`);
        });
        it(`pipe + generics: concrete type last`, () => {
            tsst_tycho_1.tsst(() => {
                let a = pipe(identity, inc)(0); // {} => number
            }).expectToFailWith(`not assignable to type 'string'`);
        });
    });
    // describe(``, () => {
    //   it(``, () => {
    //     tsst(() => {
    //       the<, <>();
    //     }).expectToCompile();
    //   });
    // });
});
