"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tsst_tycho_1 = require("tsst-tycho");
describe(`stdlib`, () => {
    describe(`Partial`, () => {
        it(`the<{ a?: 1, b?: 2 }, Partial<{ a: 1, b: 2 }>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
    });
    describe(`Readonly`, () => {
        it(`the<{ readonly a: 1 }, Readonly<{ a: 1 }>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
    });
    describe(`Pick`, () => {
        it(`the<{ a: 1 }, Pick<{ a: 1, b: 2 }, 'a'>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
    });
    describe(`Record`, () => {
        it(`the<{ a: 1, b: 1 }, Record<'a' | 'b', 1>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
    });
    describe(`Exclude`, () => {
        it(`the<1|2, Exclude<1|2|3, 3|4>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
    });
    describe(`Extract`, () => {
        it(`the<2|3, Extract<1|2|3, 2|3|4>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
    });
    describe(`NonNullable`, () => {
        it(`the<1, NonNullable<1 | null>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
    });
    describe(`ReturnType`, () => {
        it(`the<string, ReturnType<() => string>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
    });
    describe(`InstanceType`, () => {
        it(`the<string, InstanceType<new () => string>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
        it(`the<MyClass, InstanceType<typeof MyClass>>`, () => {
            tsst_tycho_1.tsst(() => {
                class MyClass {
                }
                tsst_tycho_1.the();
            }).expectToCompile();
        });
        describe(`Required`, () => {
            it(`the<{ a: 1 }, Required<{ a?: 1 }>>`, () => {
                tsst_tycho_1.tsst(() => {
                    tsst_tycho_1.the();
                }).expectToCompile();
            });
        });
    });
    // describe(``, () => {
    //   it(``, () => {
    //     tsst(() => {
    //       the<, <>>();
    //     }).expectToCompile();
    //   });
    // });
});
