"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tsst_tycho_1 = require("tsst-tycho");
describe(`built-in syntax`, () => {
    describe(`|`, () => {
        it(`the<1|2, 2>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
    });
    describe(`&`, () => {
        it(`the<1, 1&2>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
    });
    describe(`[]`, () => {
        it(`the<1, {a:1}['a']>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
    });
    describe(`keyof`, () => {
        it(`the<'a'|'b', keyof { a: 1, b: 2 }>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
    });
    describe(`in`, () => {
        it(`the<{ a: 'a' }, { [P in 'a']: P }>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
    });
    describe(`extends`, () => {
        it(`the<1, true extends boolean ? 1 : 0>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
    });
    // describe(``, () => {
    //   it(``, () => {
    //     tsst(() => {
    //       the<, <>>();
    //     }).expectToCompile();
    //   });
    // });
});
