"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tsst_tycho_1 = require("tsst-tycho");
describe(`util`, () => {
    describe(`UnionHasKey`, () => {
        it(`the<'1', UnionHasKey<'a'|'b', 'b'>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
        it(`the<'0', UnionHasKey<'a'|'b', 'c'>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
        it(`the<'1', UnionHasKey<'a'|'b', 'a'|'b'>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
        it(`the<'0', UnionHasKey<'a'|'b', 'c'|'d'>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
        it(`the<'0'|'1', UnionHasKey<'a'|'b', 'b'|'c'>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
        it(`the<'1', UnionHasKey<'a'|'b'|'toString', 'toString'>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
        it(`the<'0', UnionHasKey<'a'|'b', 'toString'>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
        // ^ error: Type '() => string' does not satisfy the constraint '"0"'.
    });
    describe(`UnionToObject`, () => {
        it(`the<{ b: 'b', c: 'c' }, UnionToObject<'b' | 'c'>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
    });
    describe(`UnionContained`, () => {
        it(`the<'1', UnionContained<never, 'a'>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
        it(`the<'1', UnionContained<'a', 'a'>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
        it(`the<'0', UnionContained<'b', 'a'>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
        it(`the<'0', UnionContained<'a' | 'b', 'a'>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
    });
    describe(`UnionEmpty`, () => {
        it(`the<'1', UnionEmpty<never>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
        it(`the<'0', UnionEmpty<'a'>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
        it(`the<'0', UnionEmpty<'a' | 'b'>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
        it(`the<'0', UnionEmpty<'toString'>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
        it(`the<'0', UnionEmpty<'toString' | 'a'>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
    });
    describe(`UnionsOverlap`, () => {
        it(`the<'1', UnionsOverlap<'a', 'a' | 'b'>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
        it(`the<'0', UnionsOverlap<'a', 'c'>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
    });
    describe(`IsUnion`, () => {
        it(`the<'1', IsUnion<'a' | 'b'>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
        it(`the<'0', IsUnion<'a'>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
        it(`the<'0', IsUnion<never>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
        it(`the<'1', IsUnion<'a' | undefined>>`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
        // ^ error: not all strings
    });
});
