"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tsst_tycho_1 = require("tsst-tycho");
describe(`util`, () => {
    describe(`the`, () => {
        it(`works with matching types`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
        it(`fails with clashing types`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToFailWith('does not satisfy');
        });
        it(`protects from never when flipped`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToFailWith('does not satisfy');
        });
        it(`protects from any`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToFailWith('does not satisfy');
        });
    });
    describe(`If`, () => {
        it(`has then`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
        it(`has else`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
    });
    describe(`Intersection`, () => {
        it(`intersects`, () => {
            tsst_tycho_1.tsst(() => {
                tsst_tycho_1.the();
            }).expectToCompile();
        });
    });
});
